/*
 *  (c) 2006 by VWP / Oxy
 *  (c) by Torkjel Hongve
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Library General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *----------------------------------------------------------------------
 */

package com.vwp.sound.mod.util.io;

import java.io.ByteArrayOutputStream;
import java.io.IOException;

public abstract class AbstractRandomAccess implements RandomAccess {

	public String readString(int len)  throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		for (int n = 0; n < len; n++)
			baos.write(readUnsignedByte());
		return new String(baos.toByteArray());
	}

	public String readZeroPaddedString(int maxLen) throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		int n = 0;
		for (; n < maxLen; n++) {
			int data = readUnsignedByte();
			if (data == 0) {
				skipBytes((maxLen-1)-n);
				break;
			}
			baos.write(data);
		}
		return new String(baos.toByteArray());
	}

	public int readUnsignedShort() throws IOException {
		return readUnsignedByte() + (readUnsignedByte() << 8);
	}

	public int readUnsignedInt() throws IOException {
		return readUnsignedShort() + (readUnsignedShort() << 16);
	}

}
